/**********************************************/
/*           Τδؿ               */
/**********************************************/
#include "jsp.h"
#include "init.h"
#include "ga_loop.h"
#include "after_treat.h"

/**********************************************/
/*           output()                         */
/*          ɽ                          */
/**********************************************/
void output()
{
  int i,j,k;
  char c;

  printf("********************Job Chart**********************\n\n");
  for(i=0;i<JobNum;i++){
    printf("Job%d:",i);
    for(j=0;j<MachineNum;j++){

      if(j==0){
	for(k=0;k<BestDataByJob[i].Machine[0].St;k++)
	  printf("-");
      }

      else {
	for(k=0;k<BestDataByJob[i].Machine[j].St-BestDataByJob[i].Machine[j-1].Ed;k++){
	  printf("-");
	}
      }

      for(k=0;k<BestDataByJob[i].Machine[j].Ed-BestDataByJob[i].Machine[j].St;k++)
	if(MachineNum<=25)
	printf("%s",int_to_char(BestDataByJob[i].Machine[j].Mn));
	else 
	  printf("%d",BestDataByJob[i].Machine[j].Mn);
    }
    
    printf("\n");
  }
  
  printf("\n");

  printf("******************Machine Chart********************\n\n");
  for(i=0;i<MachineNum;i++){
    if(MachineNum<=25)
    printf("Machine%s:",int_to_char(i));
    else printf("Machine%d",i);
    for(j=0;j<JobNum;j++){
      
      if(j==0){
	for(k=0;k<BestDataByMachine[i].Job[0].St;k++)
	  printf("-");
      }

      else {
	for(k=0;k<BestDataByMachine[i].Job[j].St - BestDataByMachine[i].Job[j-1].Ed;k++){
	  printf("-");
	}
      }
      
      for(k=0;k<BestDataByMachine[i].Job[j].Ed - BestDataByMachine[i].Job[j].St;k++)
	printf("%d",BestDataByMachine[i].Job[j].Jn);
    }
    
    
    printf("\n");
  }

  printf("****************************************************************\n\n");

  printf("=%d\n",RSeed);  
  printf("Ż=%d,=%d\n\n",JobNum,MachineNum);
  printf("ɸ:");
  for(i=0;i<ChromSize;i++){
    printf("%d.",BestOfAllChrom[i]);
  }
  printf("\n");
  printf("(%d)\n",BestOfAllGen);
  printf("Jobλ(Ŭ)=%d\n\n",BestOfAllTime);
  printf("ο=%d,=%d,Ψ=%6.3f,ѰΨ=%6.3f,꡼Ψ=%6.3f\n"
	 ,PopulationSize,MaxGeneration,CrossOverRate,MutationRate,EliteRate);

  switch (SelectionMethod){
   case 0:
	  printf("ˡ:롼å\n");
   break;
   case 1:
	  printf("ˡ:ȡʥ,(%d)\n",TournamentNum);
   break;
   case 2:
	  printf("ˡ:\n");
   break;
  };

  printf("\n****************************************************************\n");  


}
/**********************************************/
/*          int_to_char()                     */
/*          ʸѴ                */
/**********************************************/
char* int_to_char(int num)
{
  char *c;

  switch(num){
  case 0:
    c="A";break;
  case 1:
    c="B";break;
  case 2:
    c="C";break;
  case 3:
    c="D";break;
  case 4:
    c="E";break;
  case 5:
    c="F";break;
  case 6:
    c="G";break;
  case 7:
    c="H";break;
  case 8:
    c="I";break;
  case 9:
    c="J";break;
  case 10:
    c="K";break;
  case 11:
    c="J";break;
  case 12:
    c="M";break;
  case 13:
    c="N";break;
  case 14:
    c="O";break;
  case 15:
    c="P";break;
  case 16:
    c="Q";break;
  case 17:
    c="R";break;
  case 18:
    c="S";break;
  case 19:
    c="T";break;
  case 20:
    c="U";break;
  case 21:
    c="V";break;
  case 22:
    c="W";break;
  case 23:
    c="X";break;
  case 24:
    c="Y";break;
  };
  return c;
}
/**********************************************/
/*          free_parameter()                  */
/*          γ                      */
/**********************************************/
void free_parameter()
{
 free(TortalFinishTime);
 free(PopIdByFitness);
 free(BestOfAllChrom);
}


