/****************************************************************/
/*               ga_loop.c:GA򵭽                         */
/****************************************************************/
#include "jsp.h"
#include "init.h"
#include "ga_loop.h"

/**********************************************/
/*       ga_loop()                            */
/*       GA                               */
/**********************************************/
void ga_loop()
{

  int i=0;
  while(i<MaxGeneration && !TheoreticalBestFlag){
    if(i!=0)
      ga_operation();
    get_fitness();
    statistic_op(i);
    fitness_output();
    i++;
  }

  if(TheoreticalBestFlag!=0)
    printf("\n%dǺŬޤ\n",i-1);
  else 
    printf("\n򽪤ޤ\n");
}
/**********************************************/
/*       get_fitness()                        */
/*       Ŭٷ׻                           */
/**********************************************/
void get_fitness(void)
{
  int pop,jno,mno,tim,i,j,k;
  int insert_flag;
  int m_index[JobNum],j_index[MachineNum];

  /*ѿν*/
  for(pop=0;pop<PopulationSize;pop++){
    TortalFinishTime[pop]=0;
    PopIdByFitness[pop]=0;
  }
  /*ʲΤȤƤθΤФƹԤ*/
  for(pop=0;pop<PopulationSize;pop++){
   
    /*ҤƤΤ򥳥ԡ*/
    for(i=0;i<ChromSize;i++)
      ParentChrom[pop][i]=ChildChrom[pop][i];
   
    /*ȥǡν*/
    for(i=0;i<MachineNum;i++){
      for(j=0;j<JobNum;j++){
	DataByMachine[i].Job[j].St=0;
	DataByMachine[i].Job[j].Ed=0;
	DataByMachine[i].Job[j].Jn=0;
      }
      DataByMachine[i].Latest=0;
    }
    
    for(i=0;i<JobNum;i++){
      for(j=0;j<MachineNum;j++){
	DataByJob[i].Machine[j].St=0;
	DataByJob[i].Machine[j].Ed=0;
	DataByJob[i].Machine[j].Mn=0;
      }
      DataByJob[i].Latest=0;
    }

    /*ꥹȤ˥뤿index*/
    for(i=0;i<JobNum;i++)
      m_index[i]=0;
    /*jobǡ˳Ǽݤ˻Ȥindexν*/
    for(i=0;i<MachineNum;i++)
      j_index[i]=0;
    
    /**ȥǡؤγǼ**/
    
    /*ƤΰҤˤĤƹԤ*/
    for(i=0;i<ChromSize;i++){
      /*jobֹ椫鵡ֹ,֤餦*/
      jno=ParentChrom[pop][i];
      mno=MachineNoList[jno][m_index[jno]];
      tim=TimeList[jno][m_index[jno]];

      /*ε1ܤν*/
      if(j_index[mno]==0){
	DataByMachine[mno].Job[0].St =DataByJob[jno].Latest;
	DataByMachine[mno].Job[0].Ed =DataByMachine[mno].Job[0].St+tim;
	DataByMachine[mno].Job[0].Jn =jno;
	DataByMachine[mno].Latest    =DataByMachine[mno].Job[0].Ed;
	
	DataByJob[jno].Machine[m_index[jno]].St =DataByMachine[mno].Job[0].St;
	DataByJob[jno].Machine[m_index[jno]].Ed =DataByMachine[mno].Job[0].Ed;
	DataByJob[jno].Machine[m_index[jno]].Mn =mno;
	DataByJob[jno].Latest                      =DataByMachine[mno].Job[0].Ed;
      }
      
      /*2ܰʹ*/
      else {
	j=0;
	insert_flag=0;
	while(j<j_index[mno] && insert_flag==0){
	  if(((j==0)||
	      (j!=0 && DataByMachine[mno].Job[j].St - DataByMachine[mno].Job[j-1].Ed>=tim))
	     && (DataByMachine[mno].Job[j].St-tim) >= DataByJob[jno].Latest){
	    /*ҤȤĤĤ餷ƳǼ*/
	    for(k=j_index[mno];k>j;k--){
	      DataByMachine[mno].Job[k].St=DataByMachine[mno].Job[k-1].St;
	      DataByMachine[mno].Job[k].Ed=DataByMachine[mno].Job[k-1].Ed;
	      DataByMachine[mno].Job[k].Jn=DataByMachine[mno].Job[k-1].Jn;
	    }
	    /*ʬjobϿ*/
	    if(DataByMachine[mno].Job[j-1].Ed <= DataByJob[jno].Latest)
	      DataByMachine[mno].Job[j].St=DataByJob[jno].Latest;
	    else 
	      DataByMachine[mno].Job[j].St=DataByMachine[mno].Job[j-1].Ed;
	    DataByMachine[mno].Job[j].Ed=DataByMachine[mno].Job[j].St+tim;
	    DataByMachine[mno].Job[j].Jn=jno;
	    
	    DataByJob[jno].Machine[m_index[jno]].St=DataByMachine[mno].Job[j].St;
	    DataByJob[jno].Machine[m_index[jno]].Ed=DataByMachine[mno].Job[j].Ed;
	    DataByJob[jno].Latest                     =DataByMachine[mno].Job[j].Ed;
	    DataByJob[jno].Machine[m_index[jno]].Mn=mno;

	    insert_flag=1;
	  }
	  j++;
	}
	
	/*ǸˤĤ*/
	if(insert_flag==0){
	  if(DataByMachine[mno].Latest >= DataByJob[jno].Latest)
	    DataByMachine[mno].Job[j_index[mno]].St=DataByMachine[mno].Latest;
	  else
	    DataByMachine[mno].Job[j_index[mno]].St=DataByJob[jno].Latest;
	  
	  DataByMachine[mno].Job[j_index[mno]].Ed=
	    DataByMachine[mno].Job[j_index[mno]].St+tim;
	  DataByMachine[mno].Latest=
	    DataByMachine[mno].Job[j_index[mno]].St+tim;
	  DataByMachine[mno].Job[j_index[mno]].Jn=jno;

	  DataByJob[jno].Machine[m_index[jno]].St=
	    DataByMachine[mno].Job[j_index[mno]].St;
	  DataByJob[jno].Machine[m_index[jno]].Ed=
	    DataByMachine[mno].Job[j_index[mno]].Ed;
	  DataByJob[jno].Latest=
	    DataByMachine[mno].Job[j_index[mno]].Ed;
	  DataByJob[jno].Machine[m_index[jno]].Mn=mno;
	}
	
      }
      
      m_index[jno]++;
      j_index[mno]++;
    }


    /*Ŭ٤ӽθIDϿ*/
    
   for(j=0;j<JobNum;j++){
     if(TortalFinishTime[pop]<DataByJob[j].Latest)
       TortalFinishTime[pop]=DataByJob[j].Latest;
   }
   
   
   j=0;
   insert_flag=0;
   while(j<pop && insert_flag==0){
     if(TortalFinishTime[PopIdByFitness[j]]>TortalFinishTime[pop]){
       for(k=pop;k>j;k--)
	 PopIdByFitness[k]=PopIdByFitness[k-1];
       PopIdByFitness[j]=pop;
       insert_flag=1;
     }
     j++;
   }
   
   if(insert_flag==0)
     PopIdByFitness[pop]=pop;

   
   /*ɤΥȥǡ¸뤿ˤ׽*/
  if(pop==0)
    BestTimeForGant=TortalFinishTime[0];
  else if(TortalFinishTime[pop]<BestTimeForGant){
    BestTimeForGant=TortalFinishTime[pop];
    /*ɤΥȥǡ¸*/
    for(i=0;i<MachineNum;i++)
      BestDataByMachine[i]=DataByMachine[i];
    for(i=0;i<JobNum;i++)
      BestDataByJob[i]=DataByJob[i];
  }
 

 }
  

}
/**********************************************/
/*       statistic_op();                      */
/*       ׽                             */
/**********************************************/
void statistic_op(int gen)
{
  int i;
  int tmp=0;

  /*头ȤκŬ*/
  BestFinishTime=TortalFinishTime[PopIdByFitness[0]];

  /*ˤŬ*/
  if(gen==0){
    BestOfAllTime=BestFinishTime;
    BestOfAllGen=gen;
    for(i=0;i<ChromSize;i++)
      BestOfAllChrom[i]=ParentChrom[PopIdByFitness[0]][i];
  }

  else if(BestFinishTime<BestOfAllTime){
    BestOfAllTime=BestFinishTime;
    BestOfAllGen=gen;
    for(i=0;i<ChromSize;i++)
      BestOfAllChrom[i]=ParentChrom[PopIdByFitness[0]][i];
  }

  /*ʿ*/
  for(i=0;i<PopulationSize;i++)
    tmp+=TortalFinishTime[i];

  AverageFinishTime=(float)tmp/(float)PopulationSize;

  /*٥ޡλκŬȽ*/
  switch (ProblemMode){
    /*̤*/
  case 0: break;
    /*MT6-6*/
  case 1:
    if(BestFinishTime==55)
      TheoreticalBestFlag=1;
    break;
    /*MT10-10*/
  case 2:
    if(BestFinishTime==935)
      TheoreticalBestFlag=1;
    break;
    /*MT20-5*/
  case 3:
    if(BestFinishTime==1165)
      TheoreticalBestFlag=1;
    break;

    default: break;
  }

}
/**********************************************/
/*       fitness_output();                    */
/*       Ŭɽ                           */
/**********************************************/
void fitness_output()
{
  printf("BestTime=%d   ",BestFinishTime);
  printf("AverageTime=%6.3f\n",AverageFinishTime);
}
/**********************************************/
/*       ga_operation();                      */
/*                                    */
/**********************************************/
void ga_operation(void)
{
  int id1,id2,cid;
  
 /*꡼¸*/
 ga_elite();

 /*ĤλΤޤܸ*/
 cid=EliteNum;
 while(cid<PopulationSize){
   /**/
   id1 = ga_selection();
   id2 = ga_selection();  /**ƱƱΤθ򺵤򤹤ʤ餳**/
   /**/
   if(drand48()<CrossOverRate){
      ga_crossover(id1,id2,cid);
      cid+=2;
   }
   else {
    ga_copy(id1,id2,cid);   
    cid+=2;
   }
 }

 /*Ѱ*/
 ga_mutation();

}
/**********************************************/
/*       ga_elite();                          */
/*       :꡼¸                */
/**********************************************/
void ga_elite(void)
{
  int i,j;

   for(i=0;i<EliteNum;i++){
    for(j=0;j<ChromSize;j++)
      /*Ƥ椯*/
      ChildChrom[i][j]=ParentChrom[PopIdByFitness[i]][j];
  }

}
/**********************************************/
/*       ga_selection();                      */
/*       :                    */
/**********************************************/
int ga_selection(void)
{
  int i;
  int idflag[PopulationSize];
  int id,tmpid;
  float rval,tmpval;
  float reciprocal_val[PopulationSize], reciprocal_sum;

  switch(SelectionMethod){
     case 0:         /*롼å*/
       reciprocal_sum=0.0;
	/*Ŭͤ10ˤʤ褦Ŭ٤ͤεտ¸*/
	for(i=0;i<PopulationSize;i++){
	   tmpval=((TortalFinishTime[PopIdByFitness[i]]-
                    TortalFinishTime[PopIdByFitness[0]])+10);
           reciprocal_val[i]=1/tmpval;
	   reciprocal_sum+=1/tmpval; /*¤Ȥ*/
	}

	/*롼å*/
	rval=reciprocal_sum*drand48();
	/*ID򸡺*/
	id=0;
	/*tmpvalrvalã֤Ф줿IDˤʤ*/
	tmpval=reciprocal_val[0];
	while(tmpval<rval && id!=PopulationSize-1){
	  id++;
	  tmpval+=reciprocal_val[id];
	};
     break;

     case 1:         /*ȡʥ*/
	 /*ʣФʤΥե饰*/
	 for(i=0;i<PopulationSize;i++)
	   idflag[i]=0;
	 /*ID*/
	 for(i=0;i<TournamentNum;i++){
	   do{
	     tmpid=(rand()%PopulationSize);
	   }while(idflag[tmpid]==1);
	   idflag[tmpid]=1;
	   if(i==0)
	     id=tmpid;
	   /*ǤͥʸId*/
	   else if(TortalFinishTime[tmpid] < TortalFinishTime[id])
	     id=tmpid;
	 }
     break;
     
     case 2:         /**/
             id = rand()%PopulationSize;
     break;
  }

return id;
}
/**********************************************/
/*       ga_copy();                           */
/*       :ԡ                      */
/**********************************************/
void ga_copy(int id1,int id2,int cid)
{
  int i;
  /*ĤλΤĤä,Τ˾äƤ餦*/
  if(cid==PopulationSize-1)
   cid--;

  /*ƤΰҤ򥳥ԡ*/
   for(i=0;i<ChromSize;i++){
     ChildChrom[cid][i]=ParentChrom[id1][i];
     ChildChrom[cid+1][i]=ParentChrom[id2][i];
   }
}
/**********************************************/
/*       ga_crossover();                      */
/*       :                        */
/**********************************************/
void ga_crossover(int id1,int id2,int cid)
{
 int i,j,k,index1,index2,flag;
 int parent_chrom[2][ChromSize]; /*ưҤ򥳥ԡƻ*/
 int tmpid,chgflag;

 /*ĤλΤĤä,Τ˾äƤ餦*/
 if(cid==PopulationSize-1)
   cid--;

 /*ƤΰҤ򥳥ԡ*/
   for(j=0;j<ChromSize;j++){
     parent_chrom[0][j]=ParentChrom[id1][j];
     parent_chrom[1][j]=ParentChrom[id2][j];
   }

 /*򺵤2*/
 do {
   index2=rand()%ChromSize;
 } while(index2==0);
 index1=rand()%index2;

 /*ξüϤΤޤ޻Ҷ˥ԡ*/
 for(j=0;j<index1;j++){
   ChildChrom[cid][j]=parent_chrom[0][j];
   ChildChrom[cid+1][j]=parent_chrom[1][j];
 }
 for(j=index2;j<ChromSize;j++){
   ChildChrom[cid][j]=parent_chrom[0][j];
   ChildChrom[cid+1][j]=parent_chrom[1][j];
   }
 /*ν*/
 /*ҶΰҤ*/
 for(j=index1;j<index2;j++)
   ChildChrom[cid][j]=ChildChrom[cid+1][j]=-1;
 /*ƱΤƱҤܤ*/
   for(j=index1;j<index2;j++){
     k=index1;
     flag=0;
     while(k<index2 && flag==0){
       if(parent_chrom[0][j]==parent_chrom[1][k]){
	 ChildChrom[cid+1][j]=parent_chrom[0][j];
	 ChildChrom[cid][k]=parent_chrom[1][k];
	 parent_chrom[0][j]=-1;
	 parent_chrom[1][k]=-1;
	 flag=1;
       }
       k++;
     }      
   }
   /*ƤλĤҤҤζȤ*/
   for(j=index1;j<index2;j++){
     if(parent_chrom[0][j]>=0){
       k=index1;
       flag=0;
       while(k<index2 && flag==0){
	 if(ChildChrom[cid][k]<0){
	   ChildChrom[cid][k]=parent_chrom[0][j];
	   flag=1;
	 }
	 k++;
       }
     }
     
     if(parent_chrom[1][j]>=0){
       k=index1;
       flag=0;
       while(k<index2 && flag==0){
	 if(ChildChrom[cid+1][k]<0){
	   ChildChrom[cid+1][k]=parent_chrom[1][j];
	   flag=1;
	 }
	 k++;
       }
     }
   }
   
}
/**********************************************/
/*       ga_mutation();                       */
/*       :Ѱ                    */
/**********************************************/
void ga_mutation(void)
{
  int i,j,index,tmp;

 /*꡼Ȱʳ*/
 for(i=EliteNum;i<PopulationSize;i++){
   for(j=0;j<ChromSize;j++){
     if(drand48()<MutationRate){
       /*Ȥä֤*/
       do {
	 index=rand()%ChromSize;
       } while(j==index);
       /**/
       tmp=ChildChrom[i][j];
       ChildChrom[i][j]=ChildChrom[i][index];
       ChildChrom[i][index]=tmp;
     }
   }
 }
 
}









